Index: compare-new.py
===================================================================
--- compare-new.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ compare-new.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -7,5 +7,7 @@
 
 from sasmodels.bumps_model import BumpsModel, plot_data, tic
-from sasmodels.gen import opencl_model, dll_model
+from sasmodels import gpu, dll
+from sasmodels.convert import revert_model
+
 
 def sasview_model(modelname, **pars):
@@ -13,5 +15,5 @@
     Load a sasview model given the model name.
     """
-    modelname = modelname+"Model"
+    modelname = modelname
     sans = __import__('sans.models.'+modelname)
     ModelClass = getattr(getattr(sans.models,modelname,None),modelname,None)
@@ -36,5 +38,5 @@
     sasmodels = __import__('sasmodels.models.'+modelname)
     module = getattr(sasmodels.models, modelname, None)
-    kernel = opencl_model(module, dtype=dtype)
+    kernel = gpu.load_model(module, dtype=dtype)
     return kernel
 
@@ -42,22 +44,67 @@
     sasmodels = __import__('sasmodels.models.'+modelname)
     module = getattr(sasmodels.models, modelname, None)
-    kernel = dll_model(module, dtype=dtype)
+    kernel = dll.load_model(module, dtype=dtype)
     return kernel
 
-
-def compare(Ncpu, cpuname, cpupars, Ngpu, gpuname, gpupars):
-
+def randomize(p, v):
+    """
+    Randomizing pars using sasview names.
+    Guessing at angles and slds.
+    """
+    if any(p.endswith(s) for s in ('_pd_n','_pd_nsigmas','_pd_type')):
+        return v
+    if any(s in p for s in ('theta','phi','psi')):
+        return np.random.randint(0,90)
+    elif any(s in p for s in ('sld','Sld','SLD')):
+        return np.random.rand()*1e-5
+    else:
+        return np.random.rand()
+
+def parlist(pars):
+    return "\n".join("%s: %s"%(p,v) for p,v in sorted(pars.items()))
+
+def suppress_pd(pars):
+    """
+    Suppress theta_pd for now until the normalization is resolved.
+
+    May also suppress complete polydispersity of the model to test
+    models more quickly.
+    """
+    for p in pars:
+        if p.endswith("_pd"): pars[p] = 0
+
+def compare(gpuname, gpupars, Ncpu, Ngpu, opts):
     #from sasmodels.core import load_data
     #data = load_data('December/DEC07098.DAT')
-    from sasmodels.core import empty_data1D
-    data = empty_data1D(np.logspace(-4, -1, 128))
-    #from sasmodels.core import empty_2D, set_beam_stop
-    #data = empty_data2D(np.linspace(-0.05, 0.05, 128))
-    #set_beam_stop(data, 0.004)
+    qmax = 1.0 if '-highq' in opts else (0.2 if '-midq' in opts else 0.05)
+    if "-1d" in opts:
+        from sasmodels.bumps_model import empty_data1D
+        qmax = np.log10(qmax)
+        data = empty_data1D(np.logspace(qmax-3, qmax, 128))
+    else:
+        from sasmodels.bumps_model import empty_data2D, set_beam_stop
+        data = empty_data2D(np.linspace(-qmax, qmax, 128))
+        set_beam_stop(data, 0.004)
     is2D = hasattr(data, 'qx_data')
-
+    dtype = 'double' if '-double' in opts else 'single'
+    cutoff_opts = [s for s in opts if s.startswith('-cutoff')]
+    cutoff = float(cutoff_opts[0].split('=')[1]) if cutoff_opts else 1e-5
+
+
+    if '-random' in opts:
+        gpupars = dict((p,randomize(p,v)) for p,v in gpupars.items())
+    if '-pars' in opts: print "pars",parlist(gpupars)
+    if '-mono' in opts: suppress_pd(gpupars)
+
+    cpuname, cpupars = revert_model(gpuname, gpupars)
+
+    try:
+        gpumodel = load_opencl(gpuname, dtype=dtype)
+    except Exception,exc:
+        print exc
+        print "... trying again with single precision"
+        gpumodel = load_opencl(gpuname, dtype='single')
+    model = BumpsModel(data, gpumodel, cutoff=cutoff, **gpupars)
     if Ngpu > 0:
-        gpumodel = load_opencl(gpuname, dtype='single')
-        model = BumpsModel(data, gpumodel, **gpupars)
         toc = tic()
         for i in range(Ngpu):
@@ -66,10 +113,11 @@
             gpu = model.theory()
         gpu_time = toc()*1000./Ngpu
-        print "ocl t=%.1f ms, intensity=%.0f"%(gpu_time, sum(gpu[~np.isnan(gpu)]))
+        print "ocl t=%.1f ms, intensity=%f"%(gpu_time, sum(gpu[~np.isnan(gpu)]))
         #print max(gpu), min(gpu)
 
-    if 0 and Ncpu > 0: # Hack to compare ctypes vs. opencl
-        dllmodel = load_dll(gpuname, dtype='double')
-        model = BumpsModel(data, dllmodel, **gpupars)
+    comp = None
+    if Ncpu > 0 and "-dll" in opts:
+        dllmodel = load_dll(gpuname, dtype=dtype)
+        model = BumpsModel(data, dllmodel, cutoff=cutoff, **gpupars)
         toc = tic()
         for i in range(Ncpu):
@@ -77,10 +125,10 @@
             cpu = model.theory()
         cpu_time = toc()*1000./Ncpu
-        print "dll t=%.1f ms"%cpu_time
+        comp = "dll"
 
     elif 0: # Hack to check new vs old for GpuCylinder
         from Models.code_cylinder_f import GpuCylinder as oldgpu
         from sasmodel import SasModel
-        oldmodel = SasModel(data, oldgpu, dtype='single', **cpupars)
+        oldmodel = SasModel(data, oldgpu, dtype=dtype, **cpupars)
         toc = tic()
         for i in range(Ngpu):
@@ -88,5 +136,5 @@
             cpu = oldmodel.theory()
         cpu_time = toc()*1000./Ngpu
-        print "old t=%.1f ms"%cpu_time
+        comp = "old"
 
     elif Ncpu > 0:
@@ -100,14 +148,20 @@
                 cpu = cpumodel.evalDistribution(data.x)
         cpu_time = toc()*1000./Ncpu
-        print "sasview t=%.1f ms, intensity=%.0f"%(cpu_time, sum(cpu[model.index]))
-
+        comp = 'sasview'
+        #print "sasview t=%.1f ms, intensity=%.0f"%(cpu_time, sum(cpu[model.index]))
+
+    if comp:
+        print "%s t=%.1f ms, intensity=%f"%(comp, cpu_time, sum(cpu[model.index]))
     if Ngpu > 0 and Ncpu > 0:
-        print "gpu/cpu", max(abs(gpu/cpu)), "%.15g"%max(abs(gpu)), "%.15g"%max(abs(cpu))
+        #print "speedup %.2g"%(cpu_time/gpu_time)
+        #print "max |gpu/cpu|", max(abs(gpu/cpu)), "%.15g"%max(abs(gpu)), "%.15g"%max(abs(cpu))
         #cpu *= max(gpu/cpu)
-        abserr = (gpu - cpu)
-        relerr = (gpu - cpu)/cpu
-        print "max(|ocl-omp|)", max(abs(abserr[model.index]))
-        print "max(|(ocl-omp)/ocl|)", max(abs(relerr[model.index]))
-    #return
+        resid, relerr = np.zeros_like(gpu), np.zeros_like(gpu)
+        resid[model.index] = (gpu - cpu)[model.index]
+        relerr[model.index] = resid[model.index]/cpu[model.index]
+        print "max(|ocl-%s|)"%comp, max(abs(resid[model.index]))
+        print "max(|(ocl-%s)/ocl|)"%comp, max(abs(relerr[model.index]))
+
+    if '-noplot' in opts: return
 
     import matplotlib.pyplot as plt
@@ -115,5 +169,5 @@
         if Ngpu > 0: plt.subplot(131)
         plot_data(data, cpu, scale='log')
-        plt.title("omp t=%.1f ms"%cpu_time)
+        plt.title("%s t=%.1f ms"%(comp,cpu_time))
     if Ngpu > 0:
         if Ncpu > 0: plt.subplot(132)
@@ -122,26 +176,81 @@
     if Ncpu > 0 and Ngpu > 0:
         plt.subplot(133)
-        plot_data(data, 1e8*relerr, scale='linear')
-        plt.title("max rel err = %.3g"%max(abs(relerr)))
+        err = resid if '-abs' in opts else relerr
+        plot_data(data, err, scale='linear')
+        plt.title("max rel err = %.3g"%max(abs(err[model.index])))
         if is2D: plt.colorbar()
     plt.show()
 
-def rename(pars, **names):
-    newpars = pars.copy()
-    for new,old in names.items():
-        for variant in ("", "_pd", "_pd_n", "_pd_nsigma"):
-            if old+variant in newpars:
-                newpars[new+variant] = pars[old+variant]
-                del newpars[old+variant]
-    return newpars
-
-def rescale_sld(pars, names):
-    newpars = pars.copy()
-    for p in names:
-        newpars[p] *= 1e6
-    return newpars
-
 # ===========================================================================
 #
+USAGE="""
+usage: compare.py model [Nopencl] [Nsasview] [options...] [key=val]
+
+Compare the speed and value for a model between the SasView original and the
+OpenCL rewrite.
+
+model is the name of the model to compare (see below).
+Nopencl is the number of times to run the OpenCL model (default=5)
+Nsasview is the number of times to run the Sasview model (default=1)
+
+Options (* for default):
+
+    -plot*/-noplot plots or suppress the plot of the model
+    -single/-double uses double precision for comparison
+    -lowq/-midq/-highq use q values up to 0.05, 0.2 or 1.0
+    -2d/-1d uses 1d or 2d random data
+    -preset/-random randomizes the parameters
+    -poly/-mono force monodisperse/polydisperse
+    -sasview/-dll whether cpu is tested using sasview or dll
+    -cutoff=1e-5/value cutoff for including a point in polydispersity
+    -nopars/-pars prints the parameter set or not
+    -rel/-abs plot relative or absolute error
+
+Key=value pairs allow you to set specific values to any of the model
+parameters.
+
+Available models:
+
+    %s
+"""
+
+def main():
+    opts = [arg for arg in sys.argv[1:] if arg.startswith('-')]
+    args = [arg for arg in sys.argv[1:] if not arg.startswith('-')]
+    models = "\n    ".join("%-7s: %s"%(k,v.__name__.replace('_',' '))
+                           for k,v in sorted(MODELS.items()))
+    if len(args) == 0:
+        print(USAGE%models)
+        sys.exit(1)
+    if args[0] not in MODELS:
+        print "Model %r not available. Use one of:\n    %s"%(args[0],models)
+        sys.exit(1)
+
+    name, pars = MODELS[args[0]]()
+    Nopencl = int(args[1]) if len(args) > 1 else 5
+    Nsasview = int(args[2]) if len(args) > 3 else 1
+
+    # Fill in default polydispersity parameters
+    pds = set(p.split('_pd')[0] for p in pars if p.endswith('_pd'))
+    for p in pds:
+        if p+"_pd_nsigma" not in pars: pars[p+"_pd_nsigma"] = 3
+        if p+"_pd_type" not in pars: pars[p+"_pd_type"] = "gaussian"
+
+    # Fill in parameters given on the command line
+    for arg in args[3:]:
+        k,v = arg.split('=')
+        if k not in pars:
+            # extract base name without distribution
+            # style may be either a.d or a_pd_d
+            s = set((p.split('_pd')[0]).split('.')[0] for p in pars)
+            print "%r invalid; parameters are: %s"%(k,", ".join(sorted(s)))
+            sys.exit(1)
+        pars[k] = float(v) if not v.endswith('type') else v
+
+    compare(name, pars, Nsasview, Nopencl, opts)
+
+# ===========================================================================
+#
+
 MODELS = {}
 def model(name):
@@ -151,163 +260,102 @@
     return gather_function
 
-USAGE="""
-usage: compare model [Nopencl] [Nsasview]
-
-Compare the speed and value for a model between the SasView original and the
-OpenCL rewrite.
-
-* Nopencl is the number of times to run the OpenCL model (default=5)
-
-* Nsasview is the number of times to run the Sasview model (default=1)
-
-* model is the name of the model to compare:
-
-    %s
-"""
-
-def main():
-    if len(sys.argv) == 1:
-        models = "\n    ".join("%-7s: %s"%(k,v.__name__.replace('_',' '))
-                               for k,v in sorted(MODELS.items()))
-        print(USAGE%models)
-        sys.exit(1)
-
-    cpuname, cpupars, gpuname, gpupars = MODELS[sys.argv[1]]()
-    Nopencl = int(sys.argv[2]) if len(sys.argv) > 2 else 5
-    Nsasview = int(sys.argv[3]) if len(sys.argv) > 3 else 1
-
-    compare(Nsasview, cpuname, cpupars, Nopencl, gpuname, gpupars)
 
 @model('cyl')
 def cylinder():
-    cpupars = dict(
-        scale=.003, background=.1,
-        sldCyl=.291e-6, sldSolv=5.77e-6,
-        radius=264.1, length=66.96,
-        cyl_theta=85, cyl_phi=0,
-        radius_pd=0.1, radius_pd_n=10, radius_pd_nsigma=3,
-        length_pd=0.1,length_pd_n=1, length_pd_nsigma=3,
-        cyl_theta_pd=45, cyl_theta_pd_n=50, cyl_theta_pd_nsigma=3,
-        cyl_phi_pd=0.1, cyl_phi_pd_n=5, cyl_phi_pd_nsigma=3,
-        )
-    cpuname = 'Cylinder'
-
-    gpupars = rename(cpupars, theta='cyl_theta', phi='cyl_phi', sld='sldCyl', solvent_sld='sldSolv')
-    gpupars = rescale_sld(gpupars, ['sld', 'solvent_sld'])
-    gpuname = 'cylinder'
-    return cpuname, cpupars, gpuname, gpupars
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        #radius=5, length=20,
+        radius=260, length=290,
+        theta=30, phi=15,
+        radius_pd=.2, radius_pd_n=1,
+        length_pd=.2,length_pd_n=1,
+        theta_pd=15, theta_pd_n=25,
+        phi_pd=15, phi_pd_n=1,
+        )
+    return 'cylinder', pars
+
+@model('capcyl')
+def capped_cylinder():
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        radius=260, cap_radius=80000, length=290,
+        theta=30, phi=15,
+        radius_pd=.2, radius_pd_n=1,
+        cap_radius_pd=.2, cap_radius_pd_n=1,
+        length_pd=.2, length_pd_n=1,
+        theta_pd=15, theta_pd_n=25,
+        phi_pd=15, phi_pd_n=1,
+        )
+    return 'capped_cylinder', pars
+
+
+@model('cscyl')
+def core_shell_cylinder():
+    pars = dict(
+        scale=1, background=0,
+        core_sld=6e-6, shell_sld=8e-6, solvent_sld=1e-6,
+        radius=325, thickness=25, length=34.2709,
+        theta=90, phi=0,
+        radius_pd=0.1, radius_pd_n=10,
+        length_pd=0.1, length_pd_n=5,
+        thickness_pd=0.1, thickness_pd_n=5,
+        theta_pd=15.8, theta_pd_n=5,
+        phi_pd=0.0008748, phi_pd_n=5,
+        )
+    return 'core_shell_cylinder', pars
 
 
 @model('ell')
-def ellipse():
-    pars = dict(
-        scale=.027, background=4.9,
-        sldEll=.297e-6, sldSolv=5.773e-6,
-        radius_a=60, radius_b=180,
-        axis_theta=0, axis_phi=90,
-        radius_a_pd=0.1, radius_a_pd_n=10, radius_a_pd_nsigma=3,
-        radius_b_pd=0.1, radius_b_pd_n=10, radius_b_pd_nsigma=3,
-        axis_theta_pd=0.1, axis_theta_pd_n=6, axis_theta_pd_nsigma=3,
-        axis_phi_pd=0.1, axis_phi_pd_n=6, axis_phi_pd_nsigma=3,
-        )
-
-    from Models.code_ellipse import GpuEllipse as gpumodel
-    model = sasview_model('Ellipsoid', **pars)
-
-    pars = rename(pars, theta='axis_theta', phi='axis_phi', sld='sldEll', solvent_sld='sldSolv')
-    pars = rescale_sld(pars, ['sld', 'solvent_sld'])
-    return model, gpumodel, pars
-
-
-@model('cscyl')
-def core_shell_cylinder(N=1):
-    pars = dict(
-        scale= 1.77881e-06, background=223.827,
-        core_sld=1e-6, shell_sld=.291e-6, solvent_sld=7.105e-6,
-        radius=325, thickness=25, length=34.2709,
-        axis_theta=90, axis_phi=0,
-        radius_pd=0.1, radius_pd_n=10, radius_pd_nsigma=3,
-        length_pd=0.1, length_pd_n=10, length_pd_nsigma=3,
-        thickness_pd=0.1, thickness_pd_n=5, thickness_pd_nsigma=3,
-        axis_theta_pd=15.8, axis_theta_pd_n=20, axis_theta_pd_nsigma=5,
-        axis_phi_pd=0.0008748, axis_phi_pd_n=5, axis_phi_pd_nsigma=3,
-        )
-
-    model = sasview_model('CoreShellCylinder', **pars)
-    from Models.code_coreshellcyl_f import GpuCoreShellCylinder as gpumodel
-
-    pars = rename(pars, theta='axis_theta', phi='axis_phi')
-    pars = rescale_sld(pars, ['core_sld', 'shell_sld', 'solvent_sld'])
-    return model, gpumodel, pars
+def ellipsoid():
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        rpolar=50, requatorial=30,
+        theta=0, phi=0,
+        rpolar_pd=0.3, rpolar_pd_n=10,
+        requatorial_pd=0, requatorial_pd_n=10,
+        theta_pd=0, theta_pd_n=45,
+        phi_pd=0, phi_pd_n=45,
+        )
+    return 'ellipsoid', pars
 
 
 @model('ell3')
-def triaxial_ellipse(N=1):
-    pars = dict(
-        scale=0.08, background=5,
-        sldEll=7.105e-6, sldSolv=.291e-6,
-        axis_theta=0, axis_phi=0, axis_psi=0,
-        semi_axisA=15, semi_axisB=20, semi_axisC=500,
-        axis_theta_pd=20, axis_theta_pd_n=10, axis_theta_pd_nsigma=3,
-        axis_phi_pd=.1, axis_phi_pd_n=10, axis_phi_pd_nsigma=3,
-        axis_psi_pd=30, axis_psi_pd_n=5, axis_psi_pd_nsigma=3,
-        semi_axisA_pd=.1, semi_axisA_pd_n=5, semi_axisA_pd_nsigma=3,
-        semi_axisB_pd=.1, semi_axisB_pd_n=5, semi_axisB_pd_nsigma=3,
-        semi_axisC_pd=.1, semi_axisC_pd_n=5, semi_axisC_pd_nsigma=3,
-        )
-
-    model = sasview_model('TriaxialEllipsoid', **pars)
-    from Models.code_triaxialellipse import GpuTriEllipse as gpumodel
-
-    pars = rename(pars,
-                  theta='axis_theta', phi='axis_phi', psi='axis_psi',
-                  sld='sldEll', solvent_sld='sldSolv',
-                  radius_a='semi_axisA', radius_b='semi_axisB',
-                  radius_c='semi_axisC',
-                  )
-    pars = rescale_sld(pars, ['sld', 'solvent_sld'])
-    return model, gpumodel, pars
+def triaxial_ellipsoid():
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        theta=0, phi=0, psi=0,
+        req_minor=25, req_major=36, rpolar=50,
+        theta_pd=0, theta_pd_n=5,
+        phi_pd=0, phi_pd_n=5,
+        psi_pd=0, psi_pd_n=5,
+        req_minor_pd=0, req_minor_pd_n=5,
+        req_major_pd=0, req_major_pd_n=5,
+        rpolar_pd=.3, rpolar_pd_n=25,
+        )
+    return 'triaxial_ellipsoid', pars
+
+@model('sph')
+def sphere():
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        radius=120,
+        radius_pd=.3, radius_pd_n=5,
+        )
+    return 'sphere', pars
 
 @model('lam')
-def lamellar(N=1):
-    pars = dict(
-        scale=0.08, background=0.003,
-        sld_bi=5.38e-6,sld_sol=7.105e-6,
-        bi_thick=19.2946,
-        bi_thick_pd= 0.37765, bi_thick_pd_n=40, bi_thick_pd_nsigma=3,
-        )
-
-    model = sasview_model('Lamellar', **pars)
-    from Models.code_lamellar import GpuLamellar as gpumodel
-
-    pars = rename(pars, sld='sld_bi', solvent_sld='sld_sol', thickness='bi_thick')
-    pars = rescale_sld(pars, ['sld', 'solvent_sld'])
-    return model, gpumodel, pars
-
-@model('capcyl')
-def capped_cylinder(N=1):
-    pars = dict(
-        scale=.08, background=0,
-        sld_capcyl=1e-6, sld_solv=6.3e-6,
-        rad_cyl=20, rad_cap=40, len_cyl=400,
-        theta=0, phi=0,
-        rad_cyl_pd=.1, rad_cyl_pd_n=10, rad_cyl_pd_nsigma=3,
-        rad_cap_pd=.1, rad_cap_pd_n=10, rad_cap_pd_nsigma=3,
-        len_cyl_pd=.1, len_cyl_pd_n=3, len_cyl_pd_nsigma=3,
-        theta_pd=.1, theta_pd_n=3, theta_pd_nsigma=3,
-        phi_pd=.1, phi_pd_n=3, phi_pd_nsigma=3,
-        )
-
-
-    model = sasview_model('CappedCylinder', **pars)
-    from Models.code_capcyl import GpuCapCylinder as gpumodel
-
-    pars = rename(pars,
-                  sld='sld_capcyl', solvent_sld='sld_solv',
-                  length='len_cyl', radius='rad_cyl',
-                  cap_radius='rad_cap')
-    pars = rescale_sld(pars, ['sld', 'solvent_sld'])
-    return model, gpumodel, pars
-
+def lamellar():
+    pars = dict(
+        scale=1, background=0,
+        sld=6e-6, solvent_sld=1e-6,
+        thickness=40,
+        thickness_pd= 0.3, thickness_pd_n=40,
+        )
+    return 'lamellar', pars
 
 if __name__ == "__main__":
Index: sasmodels/bumps_model.py
===================================================================
--- sasmodels/bumps_model.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/bumps_model.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -140,11 +140,15 @@
     import matplotlib.pyplot as plt
     if hasattr(data, 'qx_data'):
-        img = masked_array(iq, data.mask)
+        iq = iq[:]
+        valid = np.isfinite(iq)
         if scale == 'log':
-            img[(img <= 0) | ~np.isfinite(img)] = masked
-            img = np.log10(img)
+            valid[valid] = (iq[valid] > 0)
+            iq[valid] = np.log10(iq[valid])
+        iq[~valid|data.mask] = 0
+        #plottable = iq
+        plottable = masked_array(iq, ~valid|data.mask)
         xmin, xmax = min(data.qx_data), max(data.qx_data)
         ymin, ymax = min(data.qy_data), max(data.qy_data)
-        plt.imshow(img.reshape(128,128),
+        plt.imshow(plottable.reshape(128,128),
                    interpolation='nearest', aspect=1, origin='upper',
                    extent=[xmin, xmax, ymin, ymax], vmin=vmin, vmax=vmax)
@@ -154,5 +158,6 @@
             plt.plot(data.x[idx], iq[idx])
         else:
-            idx = np.isfinite(iq) & (iq>0)
+            idx = np.isfinite(iq)
+            idx[idx] = (iq[idx]>0)
             plt.loglog(data.x[idx], iq[idx])
 
@@ -228,4 +233,5 @@
     def __init__(self, data, model, cutoff=1e-5, **kw):
         from bumps.names import Parameter
+        partype = model.info['partype']
 
         # interpret data
@@ -236,5 +242,8 @@
             self.diq = data.err_data[self.index]
             self._theory = np.zeros_like(data.data)
-            q_vectors = [data.qx_data, data.qy_data]
+            if not partype['orientation'] and not partype['magnetic']:
+                q_vectors = [np.sqrt(data.qx_data**2+data.qy_data**2)]
+            else:
+                q_vectors = [data.qx_data, data.qy_data]
         else:
             self.index = (data.x>=data.qmin) & (data.x<=data.qmax) & ~np.isnan(data.y)
@@ -258,5 +267,5 @@
             setattr(self, name, Parameter.default(value, name=name, limits=limits))
             pars.append(name)
-        for name in model.info['partype']['pd-2d']:
+        for name in partype['pd-2d']:
             for xpart,xdefault,xlimits in [
                     ('_pd', 0, limits),
Index: sasmodels/convert.py
===================================================================
--- sasmodels/convert.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
+++ sasmodels/convert.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -0,0 +1,108 @@
+"""
+Convert models to and from sasview.
+"""
+PARAMETER_MAP = {
+    'CylinderModel': dict(
+        name='cylinder',
+        cyl_theta='theta', cyl_phi='phi',
+        sldCyl='sld', sldSolv='solvent_sld',
+        ),
+    'EllipsoidModel': dict(
+        name='ellipsoid',
+        axis_theta='theta', axis_phi='phi',
+        sldEll='sld', sldSolv='solvent_sld',
+        radius_a='rpolar', radius_b='requatorial',
+        ),
+    'CoreShellCylinderModel': dict(
+        name='core_shell_cylinder',
+        axis_theta='theta', axis_phi='phi',
+        ),
+    'TriaxialEllipsoidModel': dict(
+        name='triaxial_ellipsoid',
+        axis_theta='theta', axis_phi='phi', axis_psi='psi',
+        sldEll='sld', sldSolv='solvent_sld',
+        semi_axisA='req_minor', semi_axisB='req_major', semi_axisC='rpolar',
+        ),
+    'LamellarModel': dict(
+        name='lamellar',
+        sld_bi='sld', sld_sol='solvent_sld',
+        bi_thick='thickness',
+        ),
+    'CappedCylinderModel': dict(
+        name='capped_cylinder',
+        sld_capcyl='sld', sld_solv='solvent_sld',
+        len_cyl='length', rad_cyl='radius', rad_cap='cap_radius',
+        ),
+    'SphereModel': dict(
+        name='sphere',
+        sldSph='sld', sldSolv='solvent_sld',
+        #radius='radius',  # DO NOT LIST IDENTICAL PARAMETERS!
+        ),
+    }
+
+def _reverse_map():
+    retval = {}
+    for old_name,old_map in PARAMETER_MAP.items():
+        new_name = old_map['name']
+        new_map = dict((v,k) for k,v in old_map.items() if k != 'name')
+        new_map['name'] = old_name
+        retval[new_name] = new_map
+    return retval
+REVERSE_MAP = _reverse_map()
+del _reverse_map
+
+
+def _rename_pars(pars, mapping):
+    """
+    Rename the parameters and any associated polydispersity attributes.
+    """
+    newpars = pars.copy()
+    for old,new in mapping.items():
+        # Bumps style parameter names
+        for variant in ("", "_pd", "_pd_n", "_pd_nsigma", "_pd_type"):
+            if old+variant in newpars:
+                newpars[new+variant] = pars[old+variant]
+                del newpars[old+variant]
+        # Sasview style parameter names
+        for variant in (".width", ".nsigmas", ".type", ".npts"):
+            if old+variant in newpars:
+                newpars[new+variant] = pars[old+variant]
+                del newpars[old+variant]
+    return newpars
+
+def _rescale_sld(pars):
+    """
+    rescale all sld parameters in the new model definition by 1e6 so the
+    numbers are nicer.  Relies on the fact that all sld parameters in the
+    new model definition end with sld.
+    """
+    return dict((p, (v*1e6 if p.endswith('sld') else v))
+                for p,v in pars.items())
+
+def convert_model(name, pars):
+    """
+    Convert model from old style parameter names to new style.
+    """
+    mapping = PARAMETER_MAP[name]
+    newname = mapping['name']
+    newpars = _rescale_sld(_rename_pars(pars, mapping))
+    return newname, newpars
+
+def _unscale_sld(pars):
+    """
+    rescale all sld parameters in the new model definition by 1e6 so the
+    numbers are nicer.  Relies on the fact that all sld parameters in the
+    new model definition end with sld.
+    """
+    return dict((p, (v*1e-6 if p.endswith('sld') else v))
+                for p,v in pars.items())
+
+def revert_model(name, pars):
+    """
+    Convert model from new style parameter names to old style.
+    """
+    mapping = REVERSE_MAP[name]
+    oldname = mapping['name']
+    oldpars = _rename_pars(_unscale_sld(pars), mapping)
+    return oldname, oldpars
+
Index: sasmodels/dll.py
===================================================================
--- sasmodels/dll.py	(revision ff7119b4ad066090cdffae80706883cef3d80399)
+++ sasmodels/dll.py	(revision 5d4777d1f3042abc2b98b66609abf23d3bca1828)
@@ -2,5 +2,6 @@
 C types wrapper for sasview models.
 """
-
+import sys
+import os
 import ctypes as ct
 from ctypes import c_void_p, c_int, c_double
@@ -11,4 +12,53 @@
 
 from .gen import F32, F64
+# Compiler platform details
+if sys.platform == 'darwin':
+    COMPILE = "gcc-mp-4.7 -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm -lgomp"
+elif os.name == 'nt':
+    COMPILE = "gcc -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm"
+else:
+    COMPILE = "cc -shared -fPIC -std=c99 -fopenmp -O2 -Wall %s -o %s -lm"
+DLL_PATH = "/tmp"
+
+
+def dll_path(info):
+    """
+    Path to the compiled model defined by *info*.
+    """
+    from os.path import join as joinpath, split as splitpath, splitext
+    basename = splitext(splitpath(info['filename'])[1])[0]
+    return joinpath(DLL_PATH, basename+'.so')
+
+
+def load_model(kernel_module, dtype=None):
+    """
+    Load the compiled model defined by *kernel_module*.
+
+    Recompile if any files are newer than the model file.
+
+    *dtype* is ignored.  Compiled files are always double.
+
+    The DLL is not loaded until the kernel is called so models an
+    be defined without using too many resources.
+    """
+    import tempfile
+
+    source, info = gen.make(kernel_module)
+    source_files = gen.sources(info) + [info['filename']]
+    newest = max(os.path.getmtime(f) for f in source_files)
+    dllpath = dll_path(info)
+    if not os.path.exists(dllpath) or os.path.getmtime(dllpath)<newest:
+        # Replace with a proper temp file
+        fid, filename = tempfile.mkstemp(suffix=".c",prefix="sas_"+info['name'])
+        os.fdopen(fid,"w").write(source)
+        status = os.system(COMPILE%(filename, dllpath))
+        if status != 0:
+            print "compile failed.  File is in %r"%filename
+        else:
+            ## uncomment the following to keep the generated c file
+            #os.unlink(filename); print "saving compiled file in %r"%filename
+            pass
+    return DllModel(dllpath, info)
+
 
 IQ_ARGS = [c_void_p, c_void_p, c_int, c_void_p, c_double]
@@ -124,4 +174,5 @@
     """
     def __init__(self, kernel, info, input):
+        self.info = info
         self.input = input
         self.kernel = kernel
